﻿using Benner.BeTech.Engage.AplicadoresDeEstilos.SimpleGrids;
using Benner.BeTech.Entities.BeTech;
using Benner.Tecnologia.Common;
using Benner.Tecnologia.Wes.Components;
using System.Web.UI.WebControls;

namespace Benner.BeTech.Engage.Esp.AplicadoresDeEstilos.SimpleGrids
{
    public class AplicadorDeEstilosEspecificoBeTechTarefasGrid : AplicadorDeEstilosBeTechTarefasGrid
    {
        public override void Configurar(SimpleGrid simpleGrid)
        {
            base.Configurar(simpleGrid);

            simpleGrid.GridView.RowDataBound += Grid_RowDataBound;
        }

        private void Grid_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType != DataControlRowType.DataRow)
                return;

            ConfigurarSituacao(e);
        }

        private static void ConfigurarSituacao(GridViewRowEventArgs e)
        {
            var entidade = (IEntityBase)e.Row.DataItem;

            var indexSituacao = entidade[Bt_UsuarioTarefas.FieldNames.Situacao].GetInt32();
            var horasPrevistas = entidade[Bt_UsuarioTarefas.FieldNames.HorasEstimadas].GetInt32();
            var horasRealizadas = entidade[Bt_UsuarioTarefas.FieldNames.HorasExecucao].GetInt32();

            if (indexSituacao == Bt_UsuarioTarefasSituacaoTabItens.ItemConcluida && horasRealizadas > horasPrevistas)
            {
                AddClass(e.Row, "bg-danger");
            }
        }

        private static void AddClass(GridViewRow row, string classe)
        {
            var css = row.CssClass;
            if (string.IsNullOrEmpty(css) || !css.Contains(classe))
                row.CssClass += " " + classe + " ";
        }
    }
}
