﻿using Benner.BeTech.Entities.BeTech;
using Benner.Tecnologia.Common;
using Benner.Tecnologia.Wes.Components;
using System.Web.UI.WebControls;

namespace Benner.BeTech.Engage.AplicadoresDeEstilos.SimpleGrids
{
    public interface IAplicadorDeEstilosBeTechTarefasGrid
    {
        void Configurar(SimpleGrid simpleGrid);
    }

    public class AplicadorDeEstilosBeTechTarefasGrid : IAplicadorDeEstilosBeTechTarefasGrid
    {
        private static readonly string[] TextosSituacaoCell =
            new string[]
            {
                "",
                "<span class='label bg-yellow-casablanca bold'> Aberta </span>",
                "<span class='label label-status-success bold'> Concluída </span>",
                "<span class='btn label label-md label-status-canceled bold'> Cancelada </span>",
            };

        public virtual void Configurar(SimpleGrid simpleGrid)
        {
            simpleGrid.GridView.RowDataBound += Grid_RowDataBound;
        }

        private void Grid_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType != DataControlRowType.DataRow)
                return;

            ConfigurarSituacao(e);
        }

        private static void ConfigurarSituacao(GridViewRowEventArgs e)
        {
            var celulaSituacao = e.Row.CellByName("SITUACAO");
            if (celulaSituacao is null)
                return;

            var entidade = e.Row.DataItem as IEntityBase;

            var indexSituacao = entidade[Bt_UsuarioTarefas.FieldNames.Situacao].GetInt32();

            celulaSituacao.Text = TextosSituacaoCell[indexSituacao];
        }
    }
}
