﻿using Benner.BeTech.Engage.AplicadoresDeEstilos.SimpleGrids;
using Benner.BeTech.Entities.Interfaces.Components;
using Benner.RH.BennerEngage.Pages;
using Benner.Tecnologia.Business;
using Benner.Tecnologia.Wes.Components;
using Ninject;
using System;
using System.Linq;

namespace Benner.BeTech.Engage.Pages.BeTech.Tarefas
{
    public class TarefasGridPage : RHWesPage
    {
        protected SimpleGrid TAREFAS;

        [Inject] public IConclusaoTarefaComponent ConclusaoTarefaComponent { get; set; }

        [Inject] public IAplicadorDeEstilosBeTechTarefasGrid AplicadorDeEstilosTarefasGrid { get; set; }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            TAREFAS.CommandExecute += TarefasGrid_CommandExecute;

            AplicadorDeEstilosTarefasGrid.Configurar(TAREFAS);
        }

        private void TarefasGrid_CommandExecute(object sender, GridCommandExecuteArgs e)
        {
            if (string.Equals("CMD_CANCELAR", e.Command.Name))
            {
                var handles = TAREFAS.SelectedEntitiesHandles;
                if (!handles.Any())
                    throw new BusinessException("Selecione pelo menos um registro");

                foreach (var handle in handles)
                {
                    ConclusaoTarefaComponent.Cancelar(handle);
                }
            }
        }
    }
}
