﻿using Benner.BeTech.Entities.Interfaces.Components;
using Benner.Tecnologia.Business;
using Ninject;
using System;

namespace Benner.BeTech.Entities.BeTech
{
    /// <summary>
    /// Nome da Tabela: BT_USUARIOTAREFAS.
    /// Essa é uma classe parcial, os atributos, herança e propriedades estão definidos no arquivo Bt_UsuarioTarefas.properties.cs
    /// </summary>
    public partial class Bt_UsuarioTarefas
    {
        [Inject] public IConclusaoTarefaComponent ConclusaoTarefaComponent { get; set; }

        public void Concluir(BusinessArgs args)
        {
            if (args is null)
                throw new ArgumentNullException(nameof(args));

            var entity = args.DataEntity as IBtw_UsuarioTarefaConclusao;
            if (entity is null)
                throw new BusinessException("Não foi possível recuperar os dados corretos da requisição");

            var request = new ProcessarConclusaoRequest()
            {
                BtUsuarioTarefaHandle = Handle,
                HorasExecutadas = Convert.ToInt32(entity.HorasExecutadas.Value)
            };

            ConclusaoTarefaComponent.Concluir(request);
        }
    }
}
