﻿using Ninject.Modules;
using System.Collections.Generic;
using System.Linq;

namespace Benner.BeTech.Especifico.IoC
{
    public class NucleoNinjectModule : NinjectModule
    {
        public override void Load()
        {
            Load_Modules();
        }

        private void Load_Modules()
        {
            var modulos = BuscarModulos()
                .Where(p => !KernelInstance.HasModule(p.Name));

            KernelInstance.Load(modulos);
        }

        private static IEnumerable<NinjectModule> BuscarModulos()
        {
            yield return new Engage.Esp.EspEngageNinjectModule();
        }
    }
}
