﻿using Ninject.Modules;
using System.Collections.Generic;
using System.Linq;

namespace Benner.BeTech.Nucleo.IoC
{
    public class NucleoNinjectModule : NinjectModule
    {
        public override void Load()
        {
            var modulos = BuscarModulos()
                .Where(p => !KernelInstance.HasModule(p.Name));

            KernelInstance.Load(modulos);
        }

        private static IEnumerable<NinjectModule> BuscarModulos()
        {
            yield return new Tarefas.TarefasNinjectModule();
        }
    }
}
