﻿using Benner.BeTech.Entities.Interfaces.Components;
using Benner.Tecnologia.Business;
using Ninject.Modules;
using System.Collections.Generic;
using System.Linq;

namespace Benner.BeTech.Nucleo.IoC
{
    public class NucleoNinjectModule : NinjectModule
    {
        public override void Load()
        {
            Load_Modules();

            Load_Components();
        }

        private void Load_Modules()
        {
            var modulos = BuscarModulos()
                .Where(p => !KernelInstance.HasModule(p.Name));

            KernelInstance.Load(modulos);
        }

        private static IEnumerable<NinjectModule> BuscarModulos()
        {
            yield return new Engage.EngageNinjectModule();
        }

        private void Load_Components()
        {
            BusinessComponent.RegisterProxy<IConclusaoTarefaComponent>(Kernel);
        }
    }
}
