﻿using Benner.BeTech.Entities.BeTech;
using Benner.BeTech.Entities.Interfaces.Components;
using Benner.BeTech.Tarefas.Components.ConclusaoTarefa;
using Benner.Tecnologia.Common;
using System;

namespace Benner.BeTech.Tarefas.Esp.Components.ConclusaoTarefa.Processadores
{
    internal sealed class ProcessadorEspHorasEPontos : IProcessador
    {
        public CustomizationLevel CustomizationLevel => CustomizationLevel.Especifico;

        public void Cancelar(IBt_UsuarioTarefas btUsuarioTarefa)
        {
            // não executa nada ao cancelar
        }

        public void Concluir(IBt_UsuarioTarefas btUsuarioTarefa, ProcessarConclusaoRequest request)
        {
            var multiplicadorPontos = ObterMultiplicadorDePontos(btUsuarioTarefa.HorasEstimadas.Value, request.HorasExecutadas);
            var pontuacaoFinal = Convert.ToInt64(btUsuarioTarefa.PontuacaoEstimada * multiplicadorPontos);

            btUsuarioTarefa.PontuacaoFinal = pontuacaoFinal;
        }

        private decimal ObterMultiplicadorDePontos(decimal horasEstimadas, decimal horasExecutadas)
        {
            var proporcao = horasExecutadas / horasEstimadas;

            if (proporcao <= 0.5m)
                return 2;
            if (proporcao < 0.75m)
                return 1.5m;

            if (proporcao > 1.5m)
                return 0.5m;
            if (proporcao > 1.25m)
                return 0.75m;

            return 1;
        }
    }
}
