﻿using Benner.BeTech.Entities.BeTech;
using Benner.BeTech.Entities.Interfaces.Components;
using Benner.BeTech.Tarefas.Components.ConclusaoTarefa;
using Benner.Tecnologia.Business;

namespace Benner.BeTech.Tarefas.Esp.Components.ConclusaoTarefa.Validadores
{
    internal sealed class ValidadorEspObservacao : IValidador
    {
        public void ValidarCancelamento(IBt_UsuarioTarefas btUsuarioTarefa)
        {
            // não valida nada ao cancelar
        }

        public void ValidarConclusao(IBt_UsuarioTarefas btUsuarioTarefa, ProcessarConclusaoRequest request)
        {
            if (request.HorasExecutadas > btUsuarioTarefa.HorasEstimadas && string.IsNullOrEmpty(btUsuarioTarefa.Observacoes))
                throw new BusinessException("Deve haver observações preenchidas quando as horas executadas ultrapasssar as horas estimadas");
        }
    }
}
