﻿using Benner.BeTech.Entities.BeTech;
using Benner.BeTech.Tarefas.Components;
using Benner.BeTech.Tarefas.Components.ConclusaoTarefa;
using Benner.Tecnologia.Business;
using Benner.Tecnologia.Common;
using NSubstitute;
using NUnit.Framework;

namespace Benner.BeTech.Tarefas.ComponentTests
{
    [TestFixture]
    public class ConclusaoTarefaComponentUnitTests
    {
        private ConclusaoTarefaComponent _target;

        private IProcessador[] _processadores;
        private IValidador[] _validadores;

        private IBt_UsuarioTarefas _usuarioTarefa;
        private ITransactionContext _transactionContext;

        [SetUp]
        public void SetUp()
        {
            _target = new ConclusaoTarefaComponent();
            _target.TransactionContextFactory = Substitute.For<ITransactionContextFactory>();
            _target.BtUsuarioTarefasDao = Substitute.For<IBt_UsuarioTarefasDao>();

            _transactionContext = Substitute.For<ITransactionContext>();

            _target.TransactionContextFactory
                .Begin()
                .Returns(p => _transactionContext);

            _target.BtUsuarioTarefasDao
                .Get(Arg.Any<Handle>())
                .Returns(p => _usuarioTarefa);
        }

        [Test]
        public void Rotina_Cenario_Resultado()
        {

            _target.Validadores = _validadores;
            _target.Processadores = _processadores;

            Assert.Pass("Teste executou sem erros.");
        }
    }
}