﻿using Benner.Tecnologia.Business;
using Benner.Tecnologia.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Benner.BeTech.Tarefas.Components.ConclusaoTarefa.Processadores
{
    internal interface IBeTechQueryFactory
    {
        IBeTechQuery Create(string commandText);
    }

    internal class BeTechQueryFactory : IBeTechQueryFactory
    {
        public IBeTechQuery Create(string commandText)
        {
            return new BeTechQuery(commandText);
        }
    }

    internal interface IBeTechQuery
    {
        ParameterCollection Parameters { get; }

        IEnumerable<IEntityBase> Execute();
    }


    internal class BeTechQuery : IBeTechQuery
    {
        private readonly Query _query;

        public BeTechQuery(string commandText)
        {
            _query = new Query(commandText);
        }

        public ParameterCollection Parameters { get; set; }

        public IEnumerable<IEntityBase> Execute()
        {
            return _query.Execute();
        }
    }
}
