﻿using Benner.BeTech.Entities.BeTech;
using Benner.BeTech.Entities.Interfaces.Components;
using Benner.Tecnologia.Common;
using Benner.Tecnologia.Common.Services;
using Ninject;

namespace Benner.BeTech.Tarefas.Components.ConclusaoTarefa.Processadores
{
    internal sealed class ProcessadorUsuario : IProcessador
    {
        [Inject] public ISecurityService SecurityService { get; set; }

        public CustomizationLevel CustomizationLevel => CustomizationLevel.Benner;

        public void Cancelar(IBt_UsuarioTarefas btUsuarioTarefa)
        {
            // não executa nada ao cancelar
        }

        public void Concluir(IBt_UsuarioTarefas btUsuarioTarefa, ProcessarConclusaoRequest request)
        {
            btUsuarioTarefa.UsuarioExecucao = SecurityService.GetLoggedUserName();
        }
    }
}
