﻿using Benner.BeTech.Entities.BeTech;
using Benner.BeTech.Entities.Interfaces.Components;
using Benner.Tecnologia.Business;

namespace Benner.BeTech.Tarefas.Components.ConclusaoTarefa.Validadores
{
    internal sealed class ValidadorSituacao : IValidador
    {
        public void ValidarCancelamento(IBt_UsuarioTarefas btUsuarioTarefa)
        {
            if (btUsuarioTarefa.Situacao != Bt_UsuarioTarefasSituacaoTabItens.ItemAberta)
                throw new BusinessException("A tarefa deve estar 'Aberta' para poder ser cancelada");
        }

        public void ValidarConclusao(IBt_UsuarioTarefas btUsuarioTarefa, ProcessarConclusaoRequest request)
        {
            if (btUsuarioTarefa.Situacao != Bt_UsuarioTarefasSituacaoTabItens.ItemAberta)
                throw new BusinessException("A tarefa deve estar 'Aberta' para poder ser concluída");

            if (request.HorasExecutadas <= 0)
                throw new BusinessException("As horas executadas devem ser maior que '0'");
        }
    }
}
