﻿using Benner.BeTech.Entities.Interfaces.Components;
using Benner.BeTech.Tarefas.Components;
using Benner.BeTech.Tarefas.Components.ConclusaoTarefa;
using Benner.BeTech.Tarefas.Components.ConclusaoTarefa.Processadores;
using Benner.Tecnologia.Business;
using Ninject.Modules;

namespace Benner.BeTech.Tarefas
{
    public sealed class TarefasNinjectModule : NinjectModule
    {
        public override void Load()
        {
            RegistrarComponents();

            RegistrarItensInternos();
        }

        private void RegistrarComponents()
        {
            BusinessComponent.Register<IConclusaoTarefaComponent, ConclusaoTarefaComponent>(Kernel);
        }

        private void RegistrarItensInternos()
        {
            Bind<IProcessador>()
                .To<Components.ConclusaoTarefa.Processadores.ProcessadorSituacao>();
            Bind<IProcessador>()
                .To<Components.ConclusaoTarefa.Processadores.ProcessadorHorasEPontos>();
            Bind<IProcessador>()
                .To<Components.ConclusaoTarefa.Processadores.ProcessadorUsuario>();

            Bind<IValidador>()
                .To<Components.ConclusaoTarefa.Validadores.ValidadorSituacao>();

            Bind<IBeTechQueryFactory>()
                .To<BeTechQueryFactory>();
        }
    }
}
